﻿using C1.WPF.FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WPF_C1FlexGrid_Sorting
{
    public class RowComparer : IComparer<Row>
    {
        private Column _col;
        private ListSortDirection _sortDirection;

        public RowComparer(Column col, ListSortDirection sortDirection)
        {
            _col = col;
            _sortDirection = sortDirection;
        }

        public int Compare(C1.WPF.FlexGrid.Row x, C1.WPF.FlexGrid.Row y)
        {
            var v1 = x[_col];
            var v2 = y[_col];
            // compare values
            int cmp = 0;
            if (v1 == null && v2 != null)
            {
                cmp = -1;
            }
            else if (v1 != null && v2 == null)
            {
                cmp = +1;
            }
            else if (v1 is IComparable && v2 is IComparable)
            {
                cmp = ((IComparable)v1).CompareTo(v2);
            }

            // honor sort direction
            if (_sortDirection == ListSortDirection.Descending)
            {
                cmp = -cmp;
            }

            // return result
            return cmp;
        }
    }
}
