﻿using C1.WPF.FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace WPF_C1FlexGrid_Sorting
{
    public class SortCellFactory : CellFactory
    {
        public override void CreateColumnHeaderContent(C1FlexGrid grid, Border bdr, CellRange range)
        {
            var col = grid.Columns[range.Column];
            base.CreateColumnHeaderContent(grid, bdr, range);
            if ((col.Tag != null))
            {
                if ((ListSortDirection)col.Tag == ListSortDirection.Descending)
                {
                    Grid header = new Grid();
                    TextBlock tb = new TextBlock();
                    if (bdr.Child != null)
                    {
                        if (bdr.Child.GetType() == typeof(TextBlock))
                        {
                            tb = bdr.Child as TextBlock;
                        }
                        else
                            tb = ((System.Windows.Controls.Grid)(bdr.Child)).Children[0] as TextBlock;
                    }
                    TextBlock tb1 = new TextBlock();
                    tb1.HorizontalAlignment = HorizontalAlignment.Left;
                    tb1.VerticalAlignment = VerticalAlignment.Center;
                    bdr.Child = null;
                    tb1.Text = tb.Text;
                    header.Children.Add(tb1);
                    Polygon sort = new Polygon();
                    sort.Fill = Brushes.Black;
                    sort.FillRule = FillRule.EvenOdd;
                    sort.HorizontalAlignment = HorizontalAlignment.Right;
                    sort.VerticalAlignment = VerticalAlignment.Center;
                    sort.Points = new PointCollection(new List<Point> {
                                             new Point(0, 4),
                                              new Point(8, 4),
                                              new Point(4, 0)
                                       });
                    header.Children.Add(sort);
                    bdr.Child = header;
                }
                else if ((ListSortDirection)col.Tag == ListSortDirection.Ascending)
                {
                    Grid header = new Grid();
                    TextBlock tb = new TextBlock();
                    if (bdr.Child != null)
                    {
                        if (bdr.Child.GetType() == typeof(TextBlock))
                        {
                            tb = bdr.Child as TextBlock;
                        }
                        else
                            tb = ((System.Windows.Controls.Grid)(bdr.Child)).Children[0] as TextBlock;
                    }
                    TextBlock tb1 = new TextBlock();
                    tb1.HorizontalAlignment = HorizontalAlignment.Left;
                    tb1.VerticalAlignment = VerticalAlignment.Center;
                    bdr.Child = null;                   
                    tb1.Text = tb.Text;
                    header.Children.Add(tb1);
                    Polygon sort = new Polygon();
                    sort.HorizontalAlignment = HorizontalAlignment.Right;
                    sort.VerticalAlignment = VerticalAlignment.Center;
                    sort.Fill = Brushes.Black;
                    sort.FillRule = FillRule.EvenOdd;
                    sort.Points = new PointCollection(new List<Point> {
                                             new Point(0, 0),
                                             new Point(8, 0),
                                             new Point(4, 4)
                                      });
                    header.Children.Add(sort);
                    bdr.Child = header;
                }
            }
        }
    }
}
